// Project:		Generic
// File:		usercode.cpp
// Description: This file contains the project specific code which draws a simple
//              spinning cube

#include <windows.h>
#include <GL/gl.h>
#include "glmain.h"

//////////////////////////////  Constants & Variables //////////////////////////


/////////////////////////////// Local Support Functions ////////////////////////

void draw_cube()
{
	glBegin(GL_QUADS);
		// face 0
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(-1.0, 1.0, 1.0);
		glVertex3f(1.0, 1.0, 1.0);
		glVertex3f(1.0, -1.0, 1.0);
		glVertex3f(-1.0, -1.0, 1.0);

		// face 1
		glNormal3f(0.0, 0.0, -1.0);
		glVertex3f(1.0, 1.0, -1.0);
		glVertex3f(-1.0, 1.0, -1.0);
		glVertex3f(-1.0, -1.0, -1.0);
		glVertex3f(1.0, -1.0, -1.0);

		// face 2
		glNormal3f(1.0, 0.0, 0.0);
		glVertex3f(1.0, 1.0, 1.0);
		glVertex3f(1.0, 1.0, -1.0);
		glVertex3f(1.0, -1.0, -1.0);
		glVertex3f(1.0, -1.0, 1.0);

		// face 3
		glNormal3f(-1.0, 0.0, 0.0);
		glVertex3f(-1.0, 1.0, -1.0);
		glVertex3f(-1.0, 1.0, 1.0);
		glVertex3f(-1.0, -1.0, 1.0);
		glVertex3f(-1.0, -1.0, -1.0);

		// face 4
		glNormal3f(0.0, 1.0, 0.0);
		glVertex3f(-1.0, 1.0, -1.0);
		glVertex3f(1.0, 1.0, -1.0);
		glVertex3f(1.0, 1.0, 1.0);
		glVertex3f(-1.0, 1.0, 1.0);

		// face 5
		glNormal3f(0.0, -1.0, 0.0);
		glVertex3f(-1.0, -1.0, 1.0);
		glVertex3f(1.0, -1.0, 1.0);
		glVertex3f(1.0, -1.0, -1.0);
		glVertex3f(-1.0, -1.0, -1.0);
	glEnd();
}

/////////////////////////// Functions called by glmain.cpp /////////////////////

// response to init command

void init(void)
{
	// set viewing projection

	glMatrixMode(GL_PROJECTION);
	glFrustum(-0.66F, 0.66F, -0.5F, 0.5F, 1.0F, 10.0F);

	// position viewer

	glMatrixMode(GL_MODELVIEW);
	glTranslatef(0.0, 0.0, -5.0);

	// set up viewport size

	glViewport(0, 0, win_width, win_height);

	// set up gl params

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glCullFace(GL_FRONT);
	glEnable(GL_CULL_FACE);
}

// response to update command

void update()
{
	glRotatef(1.0, 0.0, 1.0, 0.0);  // 1 degree in yaw
}

// repsonse to redraw command

void redraw(void)
{
	// clear color and depth buffers

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// draw cube

	draw_cube();

	// force draw commands to be processed

	glFlush();

	// swap buffers

	SwapBuffers(hDC);
}
